package test.pdf;


import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.imageio.ImageIO;

import org.apache.commons.io.IOUtils;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.coin.util.image.filter.ImageFilterOp;
import org.coin.util.image.shape.PdfImageShape;
import org.coin.util.pdf.itext.ITextImageUtil;
import org.coin.util.pdf.pdfbox.ReplaceTextByImage;

/**
 * @see org.apache.pdfbox.examples.util.PrintTextLocations
 *
 */
public class ImageTextLocationTest {
	public static void main(String[] args) throws Exception {
		System.out.println();
		String documentIn = "D:\\test\\CS-Convocation entretien.pdf";

		PDDocument document = PDDocument.load(documentIn);
		test3(document);
	}
	
	
	public static void test3(PDDocument document) throws Exception {
		String documentOut = "D:\\test\\CS-Convocation entretien-out.pdf";
		String signatureImage = "D:\\test\\Signature_test_out.jpg";
		String signatureImagePng = "D:\\test\\Signature_test_out.png";
				
		ReplaceTextByImage textLocation = new ReplaceTextByImage();
		// true = use PdfBox, false = use iText 
		textLocation.usePdfBoxImageShape = true;
		textLocation.setDocument(document);
		textLocation.setImageFile(signatureImage);
		textLocation.locateText("#signature#");

		int index = 1;
		for (PdfImageShape pdfImageShape : textLocation.imageShapeList) {
			Map<String, Object> mapObject = new HashMap<String, Object>();
			pdfImageShape.setId("image_" + index++);
			pdfImageShape.setMapObject(mapObject);
		}

		if (textLocation.usePdfBoxImageShape) {
			for (PdfImageShape pdfImageShape : textLocation.imageShapeList) {
				Map<String, Object> mapObject = new HashMap<String, Object>();

				pdfImageShape.biImage = ImageFilterOp.getImageWhiteTransparency(textLocation.bufferedImage);
				ImageIO.write(pdfImageShape.biImage, "png", new File(signatureImagePng));
//				pdfImageShape.biImage = textLocation.bufferedImage;
				pdfImageShape.setId("image_" + index++);
				pdfImageShape.setMapObject(mapObject);
				pdfImageShape.setDocument(textLocation.getDocument());
//				pdfImageShape.setDrawAreaLimit(true);
				pdfImageShape.draw();
				textLocation.setDocument( (PDDocument) pdfImageShape.getDocument());
			}
			textLocation.save(documentOut);
		} else {
			PDDocument newDocument = ITextImageUtil.drawAndUpdateDocument(document, textLocation.imageShapeList);
			newDocument.save(documentOut);
		}
	}
	
}
