package org.coin.util.image.shape.impl.itext;

import java.awt.print.PageFormat;
import java.io.IOException;

import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.pdmodel.PDPage;
import org.coin.util.image.shape.PdfImageShape;
import org.coin.util.image.shape.PdfShape;
import org.coin.util.image.shape.impl.pdfbox.PdfBoxTextShape;
import org.coin.util.pdf.itext.ITextImageUtil;
import org.coin.util.pdf.pdfbox.PdfBoxUtil;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

import com.itextpdf.text.DocumentException;
import com.itextpdf.text.pdf.PdfStamper;

public class ITextImageShape extends PdfImageShape {

	
	
	public void draw(int iPageNumber) 
	throws IOException {
		
		PdfStamper document = (PdfStamper )this.document;
		try {
			
			com.itextpdf.text.Image img = null;
			img = (com.itextpdf.text.Image) getObject();

			if(img == null )
			{
				img 
				 	= ITextImageUtil.getImage(
						this.biImage, 
						(float)this.positionX, 
						(float)this.positionY, 
						(float)this.imageRatio * 100, 
						this.forceBlackWhite);
				
				setObject(img);
			} else {
				img.setAbsolutePosition(
						(float)this.positionX, 
						(float)this.positionY);
				img.scalePercent((float)this.imageRatio * 100);
			}
		
		
			ITextImageUtil.addImage(
					document, 
					iPageNumber,
					img);

		} catch (DocumentException e) {
			e.printStackTrace();
		}
		
		
		if(this.drawAreaLimit)
		{
			/**
			 * TODO
			 */
		}
	}
	
	public void deserialize(Node nodeShape) throws SAXException {
		deserialize(nodeShape, this);
	}	

	public static void deserialize(
			Node nodeShape,
			PdfImageShape shapeText) 
	throws SAXException {
		//shapeText.setImageFilename( BasicDom.getChildNodeValueByNodeName(nodeShape, "text"));
		PdfBoxTextShape.deserialize(nodeShape,(PdfShape) shapeText);
	}

	
	public void setWidthProportional(double width) {
		super.setWidth(width);
		super.setHeight( this.biImage.getHeight() * width / this.biImage.getWidth()  );
	}


	@Override
	public int getPageOrientation(int iPageNumber) throws IOException {
		PDDocument document = (PDDocument )this.document;
		PDPage page = PdfBoxUtil.getPage((PDDocument) document, iPageNumber - 1);
		PageFormat pageFormat = PdfBoxUtil.getPageFormat(page);
		return pageFormat.getOrientation();
	}
	
}
