package org.coin.util.image.shape.impl.pdfbox;

import java.awt.print.PageFormat;
import java.io.IOException;

import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.pdmodel.PDPage;
import org.apache.pdfbox.pdmodel.edit.PDPageContentStream;
import org.apache.pdfbox.pdmodel.graphics.image.LosslessFactory;
import org.apache.pdfbox.pdmodel.graphics.image.PDImageXObject;
import org.coin.util.image.shape.PdfImageShape;
import org.coin.util.image.shape.PdfShape;
import org.coin.util.pdf.pdfbox.PdfBoxImageUtil;
import org.coin.util.pdf.pdfbox.PdfBoxUtil;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

public class PdfBoxImageShape extends PdfImageShape {

	public void draw(int iPageNumber) 
	throws IOException {
		PDDocument document = (PDDocument )this.document;

//		cannot modify image "on the fly"
//		Exception in thread "main" java.lang.IllegalArgumentException: Raster IntegerInterleavedRaster: width = 623 height = 435 #Bands = 1 xOff = 0 yOff = 0 dataOffset[0] 0 is incompatible with ColorModel ColorModel: #pixelBits = 8 numComponents = 1 color space = java.awt.color.ICC_ColorSpace@5d09babc transparency = 1 has alpha = false isAlphaPre = false

//		if(this.bFilterTransparency){
//			this.biImage = ImageFilterOp.getImageWhiteTransparency(this.biImage);
//		}
		
		System.out.println(document);
		System.out.println(this.biImage);
		
		PDImageXObject ximage = LosslessFactory.createFromImage(document, this.biImage);
		draw(iPageNumber, ximage);
	}
	
	public PDPageContentStream getContentStream (int iPageNumber) throws IOException 
	{
		PDPage page = PdfBoxUtil.getPage((PDDocument) document, iPageNumber - 1);
		return new PDPageContentStream((PDDocument) document, page, true, true);
	}	
	
	public void draw(int iPageNumber, PDImageXObject ximage) 
	throws IOException {
		PDPage page = PdfBoxUtil.getPage((PDDocument) document, iPageNumber - 1);
		PDPageContentStream contentStream = new PDPageContentStream((PDDocument) document, page, true, true);
		String objMapping = contentStream.addXObject(ximage);
		
		PdfBoxImageUtil.drawImage(
				page, 
				contentStream , 
//				this.dPositionX - this.dWidth ,
//				this.dPositionY - this.dHeight,
//				this.dWidth,
//				this.dHeight,
				(float)this.getPositionX(), 
				(float)this.getPositionY(), 
				(float)(this.getWidth() * this.imageRatio), 
				(float)(this.getHeight() * this.imageRatio),
				objMapping);
		
		if(this.drawAreaLimit)
		{
			PdfBoxImageUtil.drawRectangle(
					contentStream, 
					this.positionX, 
					this.positionY, 
					this.positionX + this.width,
					this.positionY - this.height);
		}
		contentStream.close();
	}
	
	public void deserialize(Node nodeShape) throws SAXException {
		deserialize(nodeShape, this);
	}	

	public static void deserialize(
			Node nodeShape,
			PdfImageShape shapeText) 
	throws SAXException {
		PdfBoxTextShape.deserialize(nodeShape,(PdfShape) shapeText);
	}

	
	public void setWidthProportional(double width) {
		super.setWidth(width);
		super.setHeight( this.biImage.getHeight() * width / this.biImage.getWidth()  );
	}


	@Override
	public int getPageOrientation(int iPageNumber) throws IOException {
		PDDocument document = (PDDocument )this.document;
		PDPage page = PdfBoxUtil.getPage((PDDocument) document, iPageNumber - 1);
		PageFormat pageFormat = PdfBoxUtil.getPageFormat(page);
		return pageFormat.getOrientation();
	}
	
}
